## atlas 3.10.3

=== CMakeLists.txt ===
if(MSVC_VERSION)
#  string(REPLACE "/STACK:10000000" "/STACK:900000000000000000"
#    CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
  string(REGEX REPLACE "(.*)/STACK:(.*) (.*)" "\\1/STACK:900000000000000000 \\3"
    CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
endif()
add_subdirectory(MATGEN)
add_subdirectory(LIN)
add_subdirectory(EIG)
macro(add_lapack_test output input target)
  set(TEST_INPUT "${LAPACK_SOURCE_DIR}/TESTING/${input}")
  set(TEST_OUTPUT "${LAPACK_BINARY_DIR}/TESTING/${output}")
  get_target_property(TEST_LOC ${target} LOCATION)
  string(REPLACE "." "_" input_name ${input})
  set(testName "${target}_${input_name}")
  if(EXISTS "${TEST_INPUT}")
    add_test(LAPACK-${testName} "${CMAKE_COMMAND}"
      -DTEST=${TEST_LOC}
      -DINPUT=${TEST_INPUT} 
      -DOUTPUT=${TEST_OUTPUT} 
      -DINTDIR=${CMAKE_CFG_INTDIR}
      -P "${LAPACK_SOURCE_DIR}/TESTING/runtest.cmake")
  endif()
endmacro(add_lapack_test)

if (BUILD_SINGLE)
add_lapack_test(stest.out stest.in xlintsts)
#
# ======== SINGLE RFP LIN TESTS ========================
add_lapack_test(stest_rfp.out stest_rfp.in xlintstrfs)
#
#
# ======== SINGLE EIG TESTS ===========================
#

add_lapack_test(snep.out nep.in xeigtsts)


add_lapack_test(ssep.out sep.in xeigtsts)


add_lapack_test(ssvd.out svd.in xeigtsts)


add_lapack_test(sec.out sec.in xeigtsts)


add_lapack_test(sed.out sed.in xeigtsts)


add_lapack_test(sgg.out sgg.in xeigtsts)


add_lapack_test(sgd.out sgd.in xeigtsts)


add_lapack_test(ssb.out ssb.in xeigtsts)


add_lapack_test(ssg.out ssg.in xeigtsts)


add_lapack_test(sbal.out sbal.in xeigtsts)


add_lapack_test(sbak.out sbak.in xeigtsts)


add_lapack_test(sgbal.out sgbal.in xeigtsts)


add_lapack_test(sgbak.out sgbak.in xeigtsts)


add_lapack_test(sbb.out sbb.in xeigtsts)


add_lapack_test(sglm.out glm.in xeigtsts)


add_lapack_test(sgqr.out gqr.in xeigtsts)


add_lapack_test(sgsv.out gsv.in xeigtsts)


add_lapack_test(scsd.out csd.in xeigtsts)


add_lapack_test(slse.out lse.in xeigtsts)
endif()

if (BUILD_DOUBLE)
#
# ======== DOUBLE LIN TESTS ===========================
add_lapack_test(dtest.out dtest.in xlintstd)
#
# ======== DOUBLE RFP LIN TESTS ========================
add_lapack_test(dtest_rfp.out dtest_rfp.in xlintstrfd)
#
# ======== DOUBLE EIG TESTS ===========================

add_lapack_test(dnep.out nep.in xeigtstd)


add_lapack_test(dsep.out sep.in xeigtstd)


add_lapack_test(dsvd.out svd.in xeigtstd)


add_lapack_test(dec.out dec.in xeigtstd)


add_lapack_test(ded.out ded.in xeigtstd)


add_lapack_test(dgg.out dgg.in xeigtstd)


add_lapack_test(dgd.out dgd.in xeigtstd)


add_lapack_test(dsb.out dsb.in xeigtstd)


add_lapack_test(dsg.out dsg.in xeigtstd)


add_lapack_test(dbal.out dbal.in xeigtstd)


add_lapack_test(dbak.out dbak.in xeigtstd)


add_lapack_test(dgbal.out dgbal.in xeigtstd)


add_lapack_test(dgbak.out dgbak.in xeigtstd)


add_lapack_test(dbb.out dbb.in xeigtstd)


add_lapack_test(dglm.out glm.in xeigtstd)


add_lapack_test(dgqr.out gqr.in xeigtstd)


add_lapack_test(dgsv.out gsv.in xeigtstd)


add_lapack_test(dcsd.out csd.in xeigtstd)


add_lapack_test(dlse.out lse.in xeigtstd)
endif()

if (BUILD_COMPLEX)
add_lapack_test(ctest.out ctest.in xlintstc)
#
# ======== COMPLEX RFP LIN TESTS ========================
add_lapack_test(ctest_rfp.out ctest_rfp.in xlintstrfc)
#
# ======== COMPLEX EIG TESTS ===========================

add_lapack_test(cnep.out nep.in xeigtstc)


add_lapack_test(csep.out sep.in xeigtstc)


add_lapack_test(csvd.out svd.in xeigtstc)


add_lapack_test(cec.out cec.in xeigtstc)


add_lapack_test(ced.out ced.in xeigtstc)


add_lapack_test(cgg.out cgg.in xeigtstc)


add_lapack_test(cgd.out cgd.in xeigtstc)


add_lapack_test(csb.out csb.in xeigtstc)


add_lapack_test(csg.out csg.in xeigtstc)


add_lapack_test(cbal.out cbal.in xeigtstc)


add_lapack_test(cbak.out cbak.in xeigtstc)


add_lapack_test(cgbal.out cgbal.in xeigtstc)


add_lapack_test(cgbak.out cgbak.in xeigtstc)


add_lapack_test(cbb.out cbb.in xeigtstc)


add_lapack_test(cglm.out glm.in xeigtstc)


add_lapack_test(cgqr.out gqr.in xeigtstc)


add_lapack_test(cgsv.out gsv.in xeigtstc)


add_lapack_test(ccsd.out csd.in xeigtstc)


add_lapack_test(clse.out lse.in xeigtstc)
endif()

if (BUILD_COMPLEX16)
#
# ======== COMPLEX16 LIN TESTS ========================
add_lapack_test(ztest.out ztest.in xlintstz)
#
# ======== COMPLEX16 RFP LIN TESTS ========================
add_lapack_test(ztest_rfp.out ztest_rfp.in xlintstrfz)
#
# ======== COMPLEX16 EIG TESTS ===========================

add_lapack_test(znep.out nep.in xeigtstz)


add_lapack_test(zsep.out sep.in xeigtstz)


add_lapack_test(zsvd.out svd.in xeigtstz)


add_lapack_test(zec.out zec.in xeigtstz)


add_lapack_test(zed.out zed.in xeigtstz)


add_lapack_test(zgg.out zgg.in xeigtstz)


add_lapack_test(zgd.out zgd.in xeigtstz)


add_lapack_test(zsb.out zsb.in xeigtstz)


add_lapack_test(zsg.out zsg.in xeigtstz)


add_lapack_test(zbal.out zbal.in xeigtstz)


add_lapack_test(zbak.out zbak.in xeigtstz)


add_lapack_test(zgbal.out zgbal.in xeigtstz)


add_lapack_test(zgbak.out zgbak.in xeigtstz)


add_lapack_test(zbb.out zbb.in xeigtstz)


add_lapack_test(zglm.out glm.in xeigtstz)


add_lapack_test(zgqr.out gqr.in xeigtstz)


add_lapack_test(zgsv.out gsv.in xeigtstz)


add_lapack_test(zcsd.out csd.in xeigtstz)


add_lapack_test(zlse.out lse.in xeigtstz)
endif()


if (BUILD_SIMPLE)
    if (BUILD_DOUBLE)
#
# ======== SINGLE-DOUBLE PROTO LIN TESTS ==============
        add_lapack_test(dstest.out dstest.in xlintstds)
    endif()
endif()


if (BUILD_COMPLEX)
    if (BUILD_COMPLEX16)
#
# ======== COMPLEX-COMPLEX16 LIN TESTS ========================
        add_lapack_test(zctest.out zctest.in xlintstzc)
    endif()
endif()

# ==============================================================================

execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${LAPACK_SOURCE_DIR}/lapack_testing.py ${LAPACK_BINARY_DIR})

=== Makefile ===

F77_TS_dir   = $(TSTdir)/F77/
C_TS_dir     = $(TSTdir)/C/
CTS_dir      = $(TOPdir)/interfaces/blas/C/testing
F77TS_dir    = $(TOPdir)/interfaces/blas/F77/testing

bindir       = $(TOPdir)/bin/

CSHELL       = /bin/csh

all      : init run san clean cleanexe

init     : F77blasinit     Cblasinit     bininit

install  :
	cp $(SRCdir)/F77/?blat?.* $(F77_TS_dir)/.
	cp $(SRCdir)/C/c_?blat?.* $(C_TS_dir)/.
#	cp $(SRCdir)/F77/sblat2.short $(F77TS_dir)/sblat2.dat
#	cp $(SRCdir)/F77/dblat2.short $(F77TS_dir)/dblat2.dat
#	cp $(SRCdir)/F77/cblat2.short $(F77TS_dir)/cblat2.dat
#	cp $(SRCdir)/F77/zblat2.short $(F77TS_dir)/zblat2.dat
#	cp $(SRCdir)/F77/sblat3.short $(F77TS_dir)/sblat3.dat
#	cp $(SRCdir)/F77/dblat3.short $(F77TS_dir)/dblat3.dat
#	cp $(SRCdir)/F77/cblat3.short $(F77TS_dir)/cblat3.dat
#	cp $(SRCdir)/F77/zblat3.short $(F77TS_dir)/zblat3.dat
#	cp $(SRCdir)/C/c_sblat2.short $(CTS_dir)/c_sblat2.dat
#	cp $(SRCdir)/C/c_dblat2.short $(CTS_dir)/c_dblat2.dat
#	cp $(SRCdir)/C/c_cblat2.short $(CTS_dir)/c_cblat2.dat
#	cp $(SRCdir)/C/c_zblat2.short $(CTS_dir)/c_zblat2.dat
#	cp $(SRCdir)/C/c_sblat3.short $(CTS_dir)/c_sblat3.dat
#	cp $(SRCdir)/C/c_dblat3.short $(CTS_dir)/c_dblat3.dat
#	cp $(SRCdir)/C/c_cblat3.short $(CTS_dir)/c_cblat3.dat
#	cp $(SRCdir)/C/c_zblat3.short $(CTS_dir)/c_zblat3.dat

F77test  : F77blasinit     F77blassan    F77blasrun    F77blasclean \
           F77blascleanexe

Ctest    : Cblasinit       Cblassan      Cblasrun      Cblasclean   \
           Cblascleanexe

bintest  : bininit                       binrun        binclean     \
           bincleanexe

san      : F77blassan      Cblassan

run      : binrun F77blasrun      Cblasrun     

clean    : F77blasclean    Cblasclean    binclean

cleanexe : F77blascleanexe Cblascleanexe bincleanexe

cleanres :
	( cd $(TSTdir)/res/; rm -f * )

F77blasinit         :
	- rm -f $(F77_TS_dir)/Make.inc
	ln -s $(TOPdir)/Make.inc $(F77_TS_dir)/Make.inc
	- rm -f $(F77_TS_dir)/Makefile
	cp $(SRCdir)/makes/Make.f77blastst $(F77_TS_dir)/Makefile
	( cd $(F77_TS_dir); $(MAKE) all TSRCdir=$(SRCdir) )
	- rm -f $(F77_TS_dir)/f77blasrun
	ln -s $(SRCdir)/makes/f77blasrun $(F77_TS_dir)/f77blasrun
	- rm -f $(F77_TS_dir)/f77blassan
	ln -s $(SRCdir)/makes/f77blassan $(F77_TS_dir)/f77blassan
F77blassan          :
	$(MAKE) install
	( cd $(F77_TS_dir); $(CSHELL) f77blassan $(TOPdir) $(ARCH) )
	- rm -f $(F77_TS_dir)/f77blassan
F77blasrun          :
	( cd $(F77_TS_dir); $(CSHELL) f77blasrun $(TOPdir) $(ARCH) )
	- rm -f $(F77_TS_dir)/f77blasrun
F77blasclean        :
	- ( cd $(F77_TS_dir); $(MAKE) clean );
	- ( cd $(TOPdir)/interfaces/blas/F77/testing/; $(MAKE) clean );
F77blascleanexe     :
	- ( cd $(F77_TS_dir); $(MAKE) cleanexe );
#	- ( cd $(F77_TS_dir); rm -f *.dat );
	- rm -rf $(TSTdir)/F77/*
	- ( cd $(TOPdir)/interfaces/blas/F77/testing/; $(MAKE) clean );
	- ( cd $(TOPdir)/interfaces/blas/F77/testing/; rm -f x* );

Cblasinit           :
	- rm -f $(C_TS_dir)/Make.inc
	ln -s $(TOPdir)/Make.inc $(C_TS_dir)/Make.inc
	- rm -f $(C_TS_dir)/Makefile
	ln -s $(SRCdir)/makes/Make.cblastst $(C_TS_dir)/Makefile
	( cd $(C_TS_dir); $(MAKE) all TSRCdir=$(SRCdir) )
	- rm -f $(C_TS_dir)/cblasrun
	ln -s $(SRCdir)/makes/cblasrun $(C_TS_dir)/cblasrun
	- rm -f $(C_TS_dir)/cblassan
	ln -s $(SRCdir)/makes/cblassan $(C_TS_dir)/cblassan
Cblassan            :
	$(MAKE) install
	( cd $(C_TS_dir); $(CSHELL) cblassan $(TOPdir) $(ARCH) )
	- rm -f $(C_TS_dir)/cblassan
Cblasrun            :
	( cd $(C_TS_dir); $(CSHELL) cblasrun $(TOPdir) $(ARCH) )
	- rm -f $(C_TS_dir)/cblasrun
Cblasclean          :
	- ( cd $(C_TS_dir); $(MAKE) clean );
	- ( cd $(TOPdir)/interfaces/blas/C/testing/; $(MAKE) clean );
Cblascleanexe       :
	- ( cd $(C_TS_dir); $(MAKE) cleanexe );
#	- ( cd $(C_TS_dir); rm -f *.dat );
	- rm -rf $(TSTdir)/C/*
	- ( cd $(TOPdir)/interfaces/blas/C/testing/; $(MAKE) clean );
	- ( cd $(TOPdir)/interfaces/blas/C/testing/; rm -f x* );

bininit             : 
	( cd $(bindir); $(MAKE) xsl1blastst   )
	( cd $(bindir); $(MAKE) xdl1blastst   )
	( cd $(bindir); $(MAKE) xcl1blastst   )
	( cd $(bindir); $(MAKE) xzl1blastst   )
	( cd $(bindir); $(MAKE) xsl2blastst   )
	( cd $(bindir); $(MAKE) xdl2blastst   )
	( cd $(bindir); $(MAKE) xcl2blastst   )
	( cd $(bindir); $(MAKE) xzl2blastst   )
	( cd $(bindir); $(MAKE) xsmmtst       )
	( cd $(bindir); $(MAKE) xdmmtst       )
	( cd $(bindir); $(MAKE) xcmmtst       )
	( cd $(bindir); $(MAKE) xzmmtst       )
	( cd $(bindir); $(MAKE) xsl3blastst   )
	( cd $(bindir); $(MAKE) xdl3blastst   )
	( cd $(bindir); $(MAKE) xcl3blastst   )
	( cd $(bindir); $(MAKE) xzl3blastst   )
	( cd $(bindir); $(MAKE) xsllttst     )
	( cd $(bindir); $(MAKE) xdllttst      )
	( cd $(bindir); $(MAKE) xcllttst      )
	( cd $(bindir); $(MAKE) xzllttst      )
	( cd $(bindir); $(MAKE) xslutst       )
	( cd $(bindir); $(MAKE) xdlutst       )
	( cd $(bindir); $(MAKE) xclutst       )
	( cd $(bindir); $(MAKE) xzlutst       )
	( cd $(bindir); $(MAKE) xsqrtst       )
	( cd $(bindir); $(MAKE) xdqrtst       )
	( cd $(bindir); $(MAKE) xcqrtst       )
	( cd $(bindir); $(MAKE) xzqrtst       )
	( cd $(bindir); $(MAKE) xsinvtst      )
	( cd $(bindir); $(MAKE) xdinvtst      )
	( cd $(bindir); $(MAKE) xcinvtst      )
	( cd $(bindir); $(MAKE) xzinvtst      )
	- grep "NCPU" $(TOPdir)/Make.inc > res/ncpu.out
	if [ -s res/ncpu.out ]; then \
	   ( cd $(bindir); $(MAKE) xsmmtst_pt       ); \
	   ( cd $(bindir); $(MAKE) xdmmtst_pt       ); \
	   ( cd $(bindir); $(MAKE) xcmmtst_pt       ); \
	   ( cd $(bindir); $(MAKE) xzmmtst_pt       ); \
	   ( cd $(bindir); $(MAKE) xsl3blastst_pt   ); \
	   ( cd $(bindir); $(MAKE) xdl3blastst_pt   ); \
	   ( cd $(bindir); $(MAKE) xcl3blastst_pt   ); \
	   ( cd $(bindir); $(MAKE) xzl3blastst_pt   ); \
	   ( cd $(bindir); $(MAKE) xsllttst_pt     ); \
	   ( cd $(bindir); $(MAKE) xdllttst_pt     ); \
	   ( cd $(bindir); $(MAKE) xcllttst_pt     ); \
	   ( cd $(bindir); $(MAKE) xzllttst_pt     ); \
	   ( cd $(bindir); $(MAKE) xslutst_pt      ); \
	   ( cd $(bindir); $(MAKE) xdlutst_pt      ); \
	   ( cd $(bindir); $(MAKE) xclutst_pt      ); \
	   ( cd $(bindir); $(MAKE) xzlutst_pt      ); \
	   ( cd $(bindir); $(MAKE) xsqrtst_pt      ); \
	   ( cd $(bindir); $(MAKE) xdqrtst_pt      ); \
	   ( cd $(bindir); $(MAKE) xcqrtst_pt      ); \
	   ( cd $(bindir); $(MAKE) xzqrtst_pt      ); \
	   ( cd $(bindir); $(MAKE) xsinvtst_pt      ); \
	   ( cd $(bindir); $(MAKE) xdinvtst_pt      ); \
	   ( cd $(bindir); $(MAKE) xcinvtst_pt      ); \
	   ( cd $(bindir); $(MAKE) xzinvtst_pt      ); \
	fi
	- rm -f $(bindir)/binrun
	ln -s $(SRCdir)/makes/binrun $(bindir)/binrun
	if [ -f /usr/bin/uname ]; then \
	   if [ "`/usr/bin/uname -m`" = "alpha" ]; then \
	      rm -f $(bindir)/Make.inc ; \
	      ln -s $(TOPdir)/Make.inc $(bindir)/Make.inc ; \
	   fi \
	fi
#	if [ -f /usr/bin/uname ]; then \
#	   if [ "`/usr/bin/uname -m`" = "alpha" ]; then \
#	      rm -f $(bindir)/Make.inc ; \
#	      sed -e 's/FLINKFLAGS = /FLINKFLAGS = -nofor_main /' \
#                 $(TOPdir)/Make.$(ARCH) > $(bindir)/Make.inc ; \
#	   fi \
#	fi
binrun              :
	( cd $(bindir); $(CSHELL) binrun $(ARCH) $(bindir) $(TSTdir) )
	- rm -f $(bindir)/binrun
binclean            :
	- ( cd $(bindir); $(MAKE) clean );
bincleanexe         :
	- ( cd $(bindir); rm -f x* );

=== EIG/Makefile ===
include ../../Make.inc
TMGLIB = $(LIBdir)/lapack_matgen.a
FORTRAN = $(F77)
OPTS = $(F77FLAGS)
DRVOPTS = $(OPTS)
NOOPTS = $(F77FLAGS) $(F77NOOPT)
LAPACKLIB = $(LAPACKlib)
#LAPACKLIB = $(FLAPACKlib)
BLASLIB = $(F77BLASlib) $(CBLASlib) $(ATLASlib)
#BLASLIB = $(PTF77BLASlib) $(PTCBLASlib) $(ATLASlib)
#BLASLIB = $(FBLASlib)
LOADER = $(FLINKER)
LOADOPTS = $(FLINKFLAGS)


########################################################################
#  This is the makefile for the eigenvalue test program from LAPACK.
#  The test files are organized as follows:
#
#     AEIGTST -- Auxiliary test routines used in all precisions
#     SCIGTST -- Auxiliary test routines used in REAL and COMPLEX
#     DZIGTST -- Auxiliary test routines used in DOUBLE PRECISION and
#                COMPLEX*16
#     SEIGTST -- Single precision real test routines
#     CEIGTST -- Single precision complex test routines
#     DEIGTST -- Double precision real test routines
#     ZEIGTST -- Double precision complex test routines
#
#  Test programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates all four test programs.
#  The executable files are called
#       xeigtsts, xeigtstd, xeigtstc, and xeigtstz
#  and are created in the next higher directory level.
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
########################################################################

AEIGTST = \
   alahdg.o \
   alasum.o \
   alasvm.o \
   alareq.o \
   ilaenv.o \
   xerbla.o \
   xlaenv.o \
   chkxer.o

SCIGTST = slafts.o slahd2.o slasum.o slatb9.o sstech.o sstect.o \
   ssvdch.o ssvdct.o ssxt1.o

SEIGTST = schkee.o \
   sbdt01.o sbdt02.o sbdt03.o \
   schkbb.o schkbd.o schkbk.o schkbl.o schkec.o \
   schkgg.o schkgk.o schkgl.o schkhs.o schksb.o schkst.o \
   sckcsd.o sckglm.o sckgqr.o sckgsv.o scklse.o scsdts.o \
   sdrges.o sdrgev.o sdrgsx.o sdrgvx.o \
   sdrvbd.o sdrves.o sdrvev.o sdrvgg.o sdrvsg.o \
   sdrvst.o sdrvsx.o sdrvvx.o \
   serrbd.o serrec.o serred.o serrgg.o serrhs.o serrst.o \
   sget02.o sget10.o sget22.o sget23.o sget24.o sget31.o \
   sget32.o sget33.o sget34.o sget35.o sget36.o \
   sget37.o sget38.o sget39.o sget51.o sget52.o sget53.o \
   sget54.o sglmts.o sgqrts.o sgrqts.o sgsvts.o \
   shst01.o slarfy.o slarhs.o slatm4.o slctes.o slctsx.o slsets.o sort01.o \
   sort03.o ssbt21.o ssgt01.o sslect.o sspt21.o sstt21.o \
   sstt22.o ssyt21.o ssyt22.o

CEIGTST = cchkee.o \
   cbdt01.o cbdt02.o cbdt03.o \
   cchkbb.o cchkbd.o cchkbk.o cchkbl.o cchkec.o \
   cchkgg.o cchkgk.o cchkgl.o cchkhb.o cchkhs.o cchkst.o \
   cckcsd.o cckglm.o cckgqr.o cckgsv.o ccklse.o ccsdts.o \
   cdrges.o cdrgev.o cdrgsx.o cdrgvx.o \
   cdrvbd.o cdrves.o cdrvev.o cdrvgg.o cdrvsg.o \
   cdrvst.o cdrvsx.o cdrvvx.o \
   cerrbd.o cerrec.o cerred.o cerrgg.o cerrhs.o cerrst.o \
   cget02.o cget10.o cget22.o cget23.o cget24.o \
   cget35.o cget36.o cget37.o cget38.o cget51.o cget52.o \
   cget54.o cglmts.o cgqrts.o cgrqts.o cgsvts.o \
   chbt21.o chet21.o chet22.o chpt21.o chst01.o \
   clarfy.o clarhs.o clatm4.o clctes.o clctsx.o clsets.o csbmv.o \
   csgt01.o cslect.o \
   cstt21.o cstt22.o cunt01.o cunt03.o

DZIGTST = dlafts.o dlahd2.o dlasum.o dlatb9.o dstech.o dstect.o \
   dsvdch.o dsvdct.o dsxt1.o

DEIGTST = dchkee.o \
   dbdt01.o dbdt02.o dbdt03.o \
   dchkbb.o dchkbd.o dchkbk.o dchkbl.o dchkec.o \
   dchkgg.o dchkgk.o dchkgl.o dchkhs.o dchksb.o dchkst.o \
   dckcsd.o dckglm.o dckgqr.o dckgsv.o dcklse.o dcsdts.o \
   ddrges.o ddrgev.o ddrgsx.o ddrgvx.o \
   ddrvbd.o ddrves.o ddrvev.o ddrvgg.o ddrvsg.o \
   ddrvst.o ddrvsx.o ddrvvx.o \
   derrbd.o derrec.o derred.o derrgg.o derrhs.o derrst.o \
   dget02.o dget10.o dget22.o dget23.o dget24.o dget31.o \
   dget32.o dget33.o dget34.o dget35.o dget36.o \
   dget37.o dget38.o dget39.o dget51.o dget52.o dget53.o \
   dget54.o dglmts.o dgqrts.o dgrqts.o dgsvts.o \
   dhst01.o dlarfy.o dlarhs.o dlatm4.o dlctes.o dlctsx.o dlsets.o dort01.o \
   dort03.o dsbt21.o dsgt01.o dslect.o dspt21.o dstt21.o \
   dstt22.o dsyt21.o dsyt22.o

ZEIGTST = zchkee.o \
   zbdt01.o zbdt02.o zbdt03.o \
   zchkbb.o zchkbd.o zchkbk.o zchkbl.o zchkec.o \
   zchkgg.o zchkgk.o zchkgl.o zchkhb.o zchkhs.o zchkst.o \
   zckcsd.o zckglm.o zckgqr.o zckgsv.o zcklse.o zcsdts.o \
   zdrges.o zdrgev.o zdrgsx.o zdrgvx.o \
   zdrvbd.o zdrves.o zdrvev.o zdrvgg.o zdrvsg.o \
   zdrvst.o zdrvsx.o zdrvvx.o \
   zerrbd.o zerrec.o zerred.o zerrgg.o zerrhs.o zerrst.o \
   zget02.o zget10.o zget22.o zget23.o zget24.o \
   zget35.o zget36.o zget37.o zget38.o zget51.o zget52.o \
   zget54.o zglmts.o zgqrts.o zgrqts.o zgsvts.o \
   zhbt21.o zhet21.o zhet22.o zhpt21.o zhst01.o \
   zlarfy.o zlarhs.o zlatm4.o zlctes.o zlctsx.o zlsets.o zsbmv.o \
   zsgt01.o zslect.o \
   zstt21.o zstt22.o zunt01.o zunt03.o

all: single complex double complex16

single: ../xeigtsts
complex: ../xeigtstc
double: ../xeigtstd
complex16: ../xeigtstz

../xeigtsts: $(SEIGTST) $(SCIGTST) $(AEIGTST) $(LAPACKLIB); \
          $(LOADER) $(LOADOPTS) -o xeigtsts \
          $(SEIGTST) $(SCIGTST) $(AEIGTST) $(TMGLIB) \
	  $(LAPACKLIB) $(BLASLIB) && mv xeigtsts $@

../xeigtstc: $(CEIGTST) $(SCIGTST) $(AEIGTST) $(LAPACKLIB); \
          $(LOADER) $(LOADOPTS) -o xeigtstc \
          $(CEIGTST) $(SCIGTST) $(AEIGTST) $(TMGLIB) \
	  $(LAPACKLIB) $(BLASLIB) && mv xeigtstc $@

../xeigtstd: $(DEIGTST) $(DZIGTST) $(AEIGTST) $(LAPACKLIB); \
          $(LOADER) $(LOADOPTS) -o xeigtstd \
          $(DEIGTST) $(DZIGTST) $(AEIGTST) $(TMGLIB) \
	  $(LAPACKLIB) $(BLASLIB) && mv xeigtstd $@

../xeigtstz: $(ZEIGTST) $(DZIGTST) $(AEIGTST) $(LAPACKLIB); \
          $(LOADER) $(LOADOPTS) -o xeigtstz \
          $(ZEIGTST) $(DZIGTST) $(AEIGTST) $(TMGLIB) \
	  $(LAPACKLIB) $(BLASLIB) && mv xeigtstz $@

$(AEIGTST): $(FRC)
$(SCIGTST): $(FRC)
$(DZIGTST): $(FRC)
$(SEIGTST): $(FRC)
$(CEIGTST): $(FRC)
$(DEIGTST): $(FRC)
$(ZEIGTST): $(FRC)

FRC:
	@FRC=$(FRC)

clean:
	rm -f *.o

schkee.o: schkee.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
dchkee.o: dchkee.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
cchkee.o: cchkee.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
zchkee.o: zchkee.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@

.f.o : ; $(FORTRAN) $(OPTS) -c $< -o $@

=== MATGEN/Makefile ===
include ../../Make.inc
TMGLIB = $(LIBdir)/lapack_matgen.a
FORTRAN = $(F77)
OPTS = $(F77FLAGS)
NOOPT = $(F77FLAGS) $(F77NOOPT)

#######################################################################
#  This is the makefile to create a library of the test matrix
#  generators used in LAPACK.  The files are organized as follows:
#
#     SCATGEN  -- Auxiliary routines called from both REAL and COMPLEX
#     DZATGEN  -- Auxiliary routines called from both DOUBLE PRECISION
#                 and COMPLEX*16
#     SMATGEN  -- Single precision real matrix generation routines
#     CMATGEN  -- Single precision complex matrix generation routines
#     DMATGEN  -- Double precision real matrix generation routines
#     ZMATGEN  -- Double precision complex matrix generation routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       tmglib.a
#  and is created at the LAPACK directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################
 
SCATGEN = slatm1.o slaran.o slarnd.o

SMATGEN = slatms.o slatme.o slatmr.o slatmt.o \
   slagge.o slagsy.o slakf2.o slarge.o slaror.o slarot.o slatm2.o \
   slatm3.o slatm5.o slatm6.o slatm7.o slahilb.o

CMATGEN = clatms.o clatme.o clatmr.o clatmt.o \
   clagge.o claghe.o clagsy.o clakf2.o clarge.o claror.o clarot.o \
   clatm1.o clarnd.o clatm2.o clatm3.o clatm5.o clatm6.o clahilb.o

DZATGEN = dlatm1.o dlaran.o dlarnd.o

DMATGEN = dlatms.o dlatme.o dlatmr.o dlatmt.o \
   dlagge.o dlagsy.o dlakf2.o dlarge.o dlaror.o dlarot.o dlatm2.o \
   dlatm3.o dlatm5.o dlatm6.o dlatm7.o dlahilb.o

ZMATGEN = zlatms.o zlatme.o zlatmr.o zlatmt.o \
   zlagge.o zlaghe.o zlagsy.o zlakf2.o zlarge.o zlaror.o zlarot.o \
   zlatm1.o zlarnd.o zlatm2.o zlatm3.o zlatm5.o zlatm6.o zlahilb.o

all:	$(TMGLIB)

ALLOBJ = $(SMATGEN) $(CMATGEN) $(SCATGEN) $(DMATGEN) $(ZMATGEN)	\
	$(DZATGEN)

$(TMGLIB): $(ALLOBJ)
	$(ARCHIVER) $(ARFLAGS) $@ $(ALLOBJ)
	$(RANLIB) $@

single: $(SMATGEN) $(SCATGEN)
	$(ARCHIVER) $(ARFLAGS) $(TMGLIB) $(SMATGEN) $(SCATGEN)
	$(RANLIB) $(TMGLIB)

complex: $(CMATGEN) $(SCATGEN)
	$(ARCHIVER) $(ARFLAGS) $(TMGLIB) $(CMATGEN) $(SCATGEN)
	$(RANLIB) $(TMGLIB)

double: $(DMATGEN) $(DZATGEN)
	$(ARCHIVER) $(ARFLAGS) $(TMGLIB) $(DMATGEN) $(DZATGEN)
	$(RANLIB) $(TMGLIB)

complex16: $(ZMATGEN) $(DZATGEN)
	$(ARCHIVER) $(ARFLAGS) $(TMGLIB) $(ZMATGEN) $(DZATGEN)
	$(RANLIB) $(TMGLIB)

$(SCATGEN): $(FRC)
$(SMATGEN): $(FRC)
$(CMATGEN): $(FRC)
$(DZATGEN): $(FRC)
$(DMATGEN): $(FRC)
$(ZMATGEN): $(FRC)
 
FRC:
	@FRC=$(FRC)

clean:
	rm -f *.o

.f.o:
	$(FORTRAN) $(OPTS) -c $< -o $@

slaran.o: slaran.f ; $(FORTRAN) $(NOOPT) -c $<
dlaran.o: dlaran.f ; $(FORTRAN) $(NOOPT) -c $<

=== TexDoc/Makefile ===
#
# xdvi -paper usr
#
atlas_install.pdf : atlas_install.tex
	pdflatex atlas_install ; pdflatex atlas_install
	- bibtex atlas_install
	pdflatex atlas_install ; pdflatex atlas_install
	rm -f atlas_install.aux atlas_install.dvi atlas_install.log \
              atlas_install.toc atlas_install.bbl atlas_install.blg \
              texput.log
atlas_devel.pdf : atlas_devel.tex
	pdflatex atlas_devel ; pdflatex atlas_devel
	rm -f atlas_devel.aux atlas_devel.dvi atlas_devel.log \
              atlas_devel.toc texput.log
atlas_devel.ps : atlas_devel.tex
	latex atlas_devel ; latex atlas_devel ; \
        dvips -o atlas_devel.ps atlas_devel ; \
	rm -f atlas_devel.aux atlas_devel.dvi atlas_devel.log \
              atlas_devel.toc texput.log
atlas_contrib.pdf : atlas_contrib.tex
	pdflatex atlas_contrib ; pdflatex atlas_contrib
	rm -f atlas_contrib.aux atlas_contrib.dvi atlas_contrib.log \
              atlas_contrib.toc texput.log
atlas_contrib.ps : atlas_contrib.tex
	latex atlas_contrib ; latex atlas_contrib ; \
        dvips -o atlas_contrib.ps atlas_contrib ; \
	rm -f atlas_contrib.aux atlas_contrib.dvi atlas_contrib.log \
              atlas_contrib.toc texput.log
lapackqref_pdf.ps :
	latex lapackqref ; latex lapackqref
	dvips -P pdf -t letter -t landscape -o $@ lapackqref
lapackqref.pdf : lapackqref_pdf.ps
	ps2pdf14 lapackqref_pdf.ps lapackqref.pdf
	rm -f lapackqref.aux lapackqref.dvi lapackqref.log \
              lapackqref.toc texput.log lapackqref_pdf.ps
lapackqref.ps : lapackqref.tex
	latex lapackqref ; latex lapackqref ; \
        dvips -tlandscape -o lapackqref.ps lapackqref ; \
	rm -f lapackqref.aux lapackqref.dvi lapackqref.log \
              lapackqref.toc texput.log
f77blasqref_pdf.ps :
	latex f77blasqref ; latex f77blasqref
	dvips -P pdf -t letter -t landscape -o $@ f77blasqref
f77blasqref.pdf : f77blasqref_pdf.ps
	ps2pdf14 f77blasqref_pdf.ps f77blasqref.pdf
	rm -f f77blasqref.aux f77blasqref.dvi f77blasqref.log \
              f77blasqref.toc texput.log f77blasqref_pdf.ps
f77blasqref.ps : f77blasqref.tex
	latex f77blasqref ; latex f77blasqref ; \
        dvips -tlandscape -o f77blasqref.ps f77blasqref ; \
	rm -f f77blasqref.aux f77blasqref.dvi f77blasqref.log \
              f77blasqref.toc texput.log
cblasqref_pdf.ps :
	latex cblasqref ; latex cblasqref
	dvips -P pdf -t letter -t landscape -o $@ cblasqref
cblasqref.pdf : cblasqref_pdf.ps
	ps2pdf14 cblasqref_pdf.ps cblasqref.pdf
	rm -f cblasqref.aux cblasqref.dvi cblasqref.log \
              cblasqref.toc texput.log cblasqref_pdf.ps
cblasqref.ps : cblasqref.tex
	latex cblasqref ; latex cblasqref ; \
        dvips -tlandscape -o cblasqref.ps cblasqref ; \
	rm -f cblasqref.aux cblasqref.dvi cblasqref.log \
              cblasqref.toc texput.log

=== CONFIG/ARCHS/Makefile ===
include ../Make.inc
arch=$(ARCH)
mach=$(ARCH)
dcc=default
cc=gcc
skc=$(skcD)
dkc=$(dkcD)
smc=$(smcD)
dmc=$(dmcD)
comps = skc=$(skc) dkc=$(dkc) smc=$(smc) dmc=$(dmc)

adefd = $(BLDdir)/ARCHS/$(mach)

tarfile : $(mach)
	- rm $(mach).tgz $(mach).tar
	tar cvf $(mach).tar $(mach)
	$(BZIP) $(mach).tar

$(mach)/kern/$(dcc) :
	mkdir $(mach)/kern/$(dcc)
$(mach)/gemm/$(dcc) :
	mkdir $(mach)/gemm/$(dcc)
$(mach)/lapack/$(dcc) :
	mkdir $(mach)/lapack/$(dcc)

res:
	mkdir res
res/goodgcc.txt : res
	echo "'$(GOODGCC)'" > res/goodgcc.txt
$(mach) :
	mkdir $(mach)
	mkdir $(mach)/kern $(mach)/gemm $(mach)/lapack
	$(MAKE) $(mach)/kern/$(skc) dcc=$(skc)
	$(MAKE) $(mach)/kern/$(dkc) dcc=$(dkc)
	$(MAKE) $(mach)/gemm/$(smc) dcc=$(smc)
	$(MAKE) $(mach)/gemm/$(dmc) dcc=$(dmc)
	$(MAKE) $(mach)/lapack/$(dmc) dcc=$(dmc)
	$(MAKE) $(mach)/lapack/$(smc) dcc=$(smc)

xnegr1 : $(SRCdir)/CONFIG/ARCHS/negr1file.c
	$(XCC) $(XCCFLAGS) -o $@ $(SRCdir)/CONFIG/ARCHS/negr1file.c
xnegmm : $(SRCdir)/CONFIG/ARCHS/negmmfile.c
	$(XCC) $(XCCFLAGS) -o $@ $(SRCdir)/CONFIG/ARCHS/negmmfile.c
xnegmv : $(SRCdir)/CONFIG/ARCHS/negmvfile.c
	$(XCC) $(XCCFLAGS) -o $@ $(SRCdir)/CONFIG/ARCHS/negmvfile.c
xnegflt : $(SRCdir)/CONFIG/ARCHS/negflt.c
	$(XCC) $(XCCFLAGS) -O -o xnegflt $(SRCdir)/CONFIG/ARCHS/negflt.c

ssys_put:
	- cp $(adefd)/kern/sMULADD $(SYSdir)/res/.
	- cp $(adefd)/kern/L1CacheSize $(SYSdir)/res/.
ssys :
	- cp $(SYSdir)/res/sMULADD $(adefd)/kern/.
	./xnegflt $(adefd)/kern/sMULADD
	- cp $(SYSdir)/res/L1CacheSize $(adefd)/kern/.
skern_put:
	- cp $(adefd)/kern/$(skc)/[s,c]TRSM_NB $(BLDdir)/tune/blas/level3/res/.
	- cp $(adefd)/kern/$(skc)/[s,c]MV[N,T]K.sum $(BLDdir)/tune/blas/gemv/res/.
	- cp  $(adefd)/kern/$(skc)/[s,c]R?K.sum $(BLDdir)/tune/blas/ger/res/.
	- cp $(adefd)/kern/$(skc)/[s,c]*_SUMM $(L1Tdir)/res/.
skern: xnegflt xnegr1 xnegmv
	rm -f $(adefd)/kern/$(skc)/[s,c]*
	- cp $(BLDdir)/tune/blas/level3/res/[s,c]TRSM_NB $(adefd)/kern/$(skc)/.
	- cp $(BLDdir)/tune/blas/gemv/res/[s,c]MV[N,T]K.sum $(adefd)/kern/$(skc)/.
	- cp $(BLDdir)/tune/blas/ger/res/[s,c]R?K.sum $(adefd)/kern/$(skc)/.
	./xnegmv  $(adefd)/kern/$(skc)/[s,c]MVNK.sum
	./xnegmv  $(adefd)/kern/$(skc)/[s,c]MVTK.sum
	./xnegr1 $(adefd)/kern/$(skc)/[s,c]R?K.sum
	- cp $(L1Tdir)/res/[s,c]*_SUMM $(adefd)/kern/$(skc)/.
sgemm_put:
	- cp $(adefd)/gemm/$(smc)/[s,c]MMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]gMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]guMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]eMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]MMKSSE.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Clean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]best[N,T][N,T]_* $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uMMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uClean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uClean[M,N,K]F $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]nreg $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]fpuMM $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]NCNB $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Xover.h $(INCAdir)/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Xover.h $(MMTdir)/res/.
sgemm: xnegflt xnegmm
	rm -f $(adefd)/gemm/$(smc)/[s,c]*
	- cp $(MMTdir)/res/[s,c]Clean[M,N,K] $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]best[N,T][N,T]_* $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uMMRES $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uClean[M,N,K] $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uClean[M,N,K]F $(adefd)/gemm/$(smc)/.
	./xnegflt $(adefd)/gemm/$(smc)/*
	- cp $(MMTdir)/res/[s,c]MMRES.sum $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]gMMRES.sum $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]guMMRES.sum $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]eMMRES.sum $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]MMKSSE.sum $(adefd)/gemm/$(smc)/.
	- ./xnegmm $(adefd)/gemm/$(smc)/*MM*.sum
	- cp $(MMTdir)/res/[s,c]nreg $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]fpuMM $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]NCNB $(adefd)/gemm/$(smc)/.
	- cp $(INCAdir)/[s,c]Xover.h $(adefd)/gemm/$(smc)/.
sla_get:
	rm -f $(adefd)/lapack/$(smc)/atlas_[s,c]GetNB_*.h
	for file in $(INCAdir)/atlas_[s,c]GetNB_*.h ; do \
           if [ -s "$${file}" ]; then \
	      cp $${file} $(adefd)/lapack/$(smc)/. ; \
           fi \
        done
	rm -f $(adefd)/lapack/$(smc)/atlas_[s,c]tGetNB_*.h
	for file in $(INCAdir)/atlas_[s,c]tGetNB_*.h ; do \
           if [ -s "$${file}" ]; then \
	      cp $${file} $(adefd)/lapack/$(smc)/. ; \
           fi \
        done
sla_put :
	- cp $(adefd)/lapack/$(smc)/atlas_[s,c]GetNB_*.h $(INCAdir)/.
	- cp $(adefd)/lapack/$(smc)/atlas_[s,c]tGetNB_*.h $(INCAdir)/.
dsys_put:
	- cp $(adefd)/kern/dMULADD $(SYSdir)/res/.
	- cp $(adefd)/kern/L1CacheSize $(SYSdir)/res/.
dsys :
	- cp $(SYSdir)/res/dMULADD $(adefd)/kern/.
	./xnegflt $(adefd)/kern/dMULADD
	- cp $(SYSdir)/res/L1CacheSize $(adefd)/kern/.
dkern_put:
	- cp $(adefd)/kern/$(dkc)/[d,z]TRSM_NB $(BLDdir)/tune/blas/level3/res/.
	- cp $(adefd)/kern/$(dkc)/[d,z]MV[N,T]K.sum $(BLDdir)/tune/blas/gemv/res/.
	- cp  $(adefd)/kern/$(dkc)/[d,z]R?K.sum $(BLDdir)/tune/blas/ger/res/.
	- cp $(adefd)/kern/$(dkc)/[d,z]*_SUMM $(L1Tdir)/res/.
dkern: xnegflt xnegr1 xnegmv
	rm -f $(adefd)/kern/$(dkc)/[d,z]*
	- cp $(BLDdir)/tune/blas/level3/res/[d,z]TRSM_NB $(adefd)/kern/$(dkc)/.
	- cp $(BLDdir)/tune/blas/gemv/res/[d,z]MV[N,T]K.sum $(adefd)/kern/$(dkc)/.
	- cp $(BLDdir)/tune/blas/ger/res/[d,z]R?K.sum $(adefd)/kern/$(dkc)/.
	./xnegmv  $(adefd)/kern/$(dkc)/[d,z]MVNK.sum
	./xnegmv  $(adefd)/kern/$(dkc)/[d,z]MVTK.sum
	./xnegr1 $(adefd)/kern/$(dkc)/[d,z]R?K.sum
	- cp $(L1Tdir)/res/[d,z]*_SUMM $(adefd)/kern/$(dkc)/.
dgemm_put:
	- cp $(adefd)/gemm/$(dmc)/[d,z]MMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]gMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]guMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]eMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]MMKSSE.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Clean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]best[N,T][N,T]_* $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uMMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uClean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uClean[M,N,K]F $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]nreg $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]fpuMM $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]NCNB $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Xover.h $(INCAdir)/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Xover.h $(MMTdir)/res/.
dgemm: xnegflt xnegmm
	rm -f $(adefd)/gemm/$(dmc)/[d,z]*
	- cp $(MMTdir)/res/[d,z]Clean[M,N,K] $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]best[N,T][N,T]_* $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uMMRES $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uClean[M,N,K] $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uClean[M,N,K]F $(adefd)/gemm/$(dmc)/.
	./xnegflt $(adefd)/gemm/$(dmc)/*
	- cp $(MMTdir)/res/[d,z]MMRES.sum $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]gMMRES.sum $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]guMMRES.sum $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]eMMRES.sum $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]MMKSSE.sum $(adefd)/gemm/$(dmc)/.
	- ./xnegmm $(adefd)/gemm/$(dmc)/*MM*.sum
	- cp $(MMTdir)/res/[d,z]nreg $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]fpuMM $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]NCNB $(adefd)/gemm/$(dmc)/.
	- cp $(INCAdir)/[d,z]Xover.h $(adefd)/gemm/$(dmc)/.
dla_get:
	rm -f $(adefd)/lapack/$(dmc)/atlas_[d,z]GetNB_*.h
	for file in $(INCAdir)/atlas_[d,z]GetNB_*.h ; do \
           if [ -s "$${file}" ]; then \
	      cp $${file} $(adefd)/lapack/$(dmc)/. ; \
           fi \
        done
	rm -f $(adefd)/lapack/$(dmc)/atlas_[d,z]tGetNB_*.h
	for file in $(INCAdir)/atlas_[d,z]tGetNB_*.h ; do \
           if [ -s "$${file}" ]; then \
	      cp $${file} $(adefd)/lapack/$(dmc)/. ; \
           fi \
        done
dla_put :
	- cp $(adefd)/lapack/$(dmc)/atlas_[d,z]GetNB_*.h $(INCAdir)/.
	- cp $(adefd)/lapack/$(dmc)/atlas_[d,z]tGetNB_*.h $(INCAdir)/.

la_get : sla_get dla_get
la_put : sla_put dla_put
sys_put : ssys_put dsys_put
kern_put : skern_put dkern_put
gemm_put : sgemm_put dgemm_put
	- cp $(adefd)/gemm/atlas_cacheedge.h $(INCAdir)/.
	- cp $(adefd)/gemm/atlas_cacheedge.h $(MMTdir)/res/.
	- cp $(adefd)/gemm/atlas_tcacheedge.h $(INCAdir)/.
	- cp $(adefd)/gemm/atlas_tcacheedge.h $(MMTdir)/res/.
	- cp $(adefd)/gemm/atlas_??NKB.h $(INCAdir)/.
	- cp $(adefd)/gemm/atlas_??NKB.h $(MMTdir)/res/.
sys : ssys dsys
kern : skern dkern
gemm : sgemm dgemm
	- cp $(INCAdir)/atlas_cacheedge.h $(adefd)/gemm/
	- cp $(INCAdir)/atlas_tcacheedge.h $(adefd)/gemm/
	- cp $(INCAdir)/atlas_??NKB.h $(adefd)/gemm/
ArchNew : $(mach) xnegflt
	$(MAKE) sys kern gemm la_get
	- cp $(BLDdir)/bin/INSTALL_LOG/?PerfSumm.txt $(adefd)/.
	rm -f xnegflt
archput : sys_put kern_put gemm_put la_put

=== CONFIG/src/Makefile ===
SHELL=/bin/sh
SRCdir = $(TOPdir)/CONFIG/src
INCdir = $(TOPdir)/CONFIG/include
mydir = $(BLDdir)
atlrun = atlas_run
INCFLAGS = -I$(INCdir)
MYFLAGS =
CCFLAGS = $(INCFLAGS) $(MYFLAGS) $(CFLAGS)
XCC = $(CC)
XCFLAGS = $(CCFLAGS)
LIBS =
args =
rdir = /tmp
arch=
BUNZIP = bunzip2
TAR = tar
wind=$(BLDdir)

all : build
xconfig : $(SRCdir)/config.c atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xconfig $(SRCdir)/config.c atlconf_misc.o $(LIBS)
xspew : $(SRCdir)/SpewMakeInc.c atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xspew $(SRCdir)/SpewMakeInc.c atlconf_misc.o \
               $(LIBS)
xisgcc : $(SRCdir)/IsGcc.c atlconf_misc.o
	$(XCC) $(XCFLAGS) -o $@ $(SRCdir)/IsGcc.c atlconf_misc.o $(LIBS)
mgwgfortran : $(SRCdir)/mgwcmp.c
	$(XCC) $(XCCFLAGS) "-DDEFDF=$(cmppath)" -o $@ $(SRCdir)/mgwcmp.c
mgwgcc : $(SRCdir)/mgwcmp.c
	$(XCC) $(XCCFLAGS) "-DDEFDF=$(cmppath)" -o $@ $(SRCdir)/mgwcmp.c
mgwar : $(SRCdir)/mgwcmp.c
	$(XCC) $(XCCFLAGS) "-DDEFDF=$(cmppath)" -o $@ $(SRCdir)/mgwcmp.c
mgwranlib : $(SRCdir)/mgwcmp.c
	$(XCC) $(XCCFLAGS) "-DDEFDF=$(cmppath)" -o $@ $(SRCdir)/mgwcmp.c

$(wind)/ATLwin_ifort.exe : $(SRCdir)/winf77.c
	cp $(SRCdir)/wincc.c $(wind)/.
	cd $(wind) ; icl /FeATLwin_ifort.exe /DDEFDF=ifort wincc.c
	rm -f $(wind)/wincc.c
$(wind)/ATLwin_icc.exe : $(SRCdir)/wincc.c
	cp $(SRCdir)/wincc.c $(wind)/.
	cd $(wind) ; icl /FeATLwin_icc.exe /DDEFDF=icl wincc.c
	rm -f $(wind)/wincc.c
$(wind)/ATLwin_cl.exe : $(SRCdir)/wincc.c
	cp $(SRCdir)/wincc.c $(wind)/.
	cd $(wind) ; cl /FeATLwin_cl.exe /DDEFDF=cl wincc.c
	rm -f $(wind)/wincc.c
xprobe_comp : xisgcc probe_comp.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_comp probe_comp.o atlconf_misc.o $(LIBS)
xprobe_aff : probe_aff.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_aff probe_aff.o atlconf_misc.o $(LIBS)
xprobe_pmake : probe_pmake.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_pmake probe_pmake.o atlconf_misc.o $(LIBS)
xprobe_f2c : probe_f2c.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_f2c probe_f2c.o atlconf_misc.o $(LIBS)
xprobe_arch : probe_arch.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_arch probe_arch.o atlconf_misc.o $(LIBS)
xprobe_vec : probe_vec.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_vec probe_vec.o atlconf_misc.o $(LIBS)
xprobe_asm : probe_asm.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_asm probe_asm.o atlconf_misc.o $(LIBS)
xprobe_OS : probe_OS.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_OS probe_OS.o atlconf_misc.o $(LIBS)

xprint_enums : $(SRCdir)/print_enums.c
	$(XCC) $(XCFLAGS) -o xprint_enums $(SRCdir)/print_enums.c
xatlbench : atlbench.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xatlbench atlbench.o atlconf_misc.o
probe_aff.o : $(SRCdir)/probe_aff.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_aff.c
atlbench.o : $(SRCdir)/atlbench.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/atlbench.c
probe_pmake.o : $(SRCdir)/probe_pmake.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_pmake.c
probe_f2c.o : $(SRCdir)/probe_f2c.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_f2c.c
probe_comp.o : $(SRCdir)/probe_comp.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_comp.c
probe_arch.o : $(SRCdir)/probe_arch.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_arch.c
probe_vec.o : $(SRCdir)/probe_vec.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_vec.c
probe_asm.o : $(SRCdir)/probe_asm.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_asm.c
probe_OS.o : $(SRCdir)/probe_OS.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_OS.c
atlconf_misc.o : $(SRCdir)/atlconf_misc.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/atlconf_misc.c
atlconf_misc_BE.o : $(SRCdir)/atlconf_misc.c
	$(CC) $(CCFLAGS) -o atlconf_misc_BE.o -c $(SRCdir)/atlconf_misc.c

atlas_run :
	cd $(atldir) ; ./$(exe) $(args) > $(redir)
atlas_runX :
	scp $(atldir)/$(exe) $(targ):$(rdir)/$(exe)
	ssh $(targ) 'cd $(rdir) ; ./$(exe) $(args)' > $(redir)
force_build:

#
# General probes always ran locally (possibly cross-compiling machine)
# General probes call system (they're essentially shell scripts)
#
IRun_comp: xprobe_comp force_build
	- rm -f config1.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_comp redir=config1.out \
                args="$(args) -d b $(BLDdir)"
	- cat config1.out
IRun_OS: xprobe_OS force_build
	- rm -f config1.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_OS args="$(args)" \
                redir=config1.out
	- cat config1.out
IRun_aff: xprobe_aff force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_aff args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_pmake: xprobe_pmake force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_pmake args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_arch: xprobe_arch force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_arch args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_vec: xprobe_vec force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_vec args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_asm: xprobe_asm force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_asm args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_f2c: xprobe_f2c force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_f2c args="$(args)" \
                redir=config2.out
	- cat config2.out

#
# Machine-level probes run on machine lib being compiled for
# These probes do not call system, but actually do something
#
IRun_ARM_HARDFP :
	$(CC) $(CCFLAGS) -o xprobe_hardfp \
              $(SRCdir)/backend/probe_arm32_FPABI.c \
              $(SRCdir)/backend/hardfptst.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_hardfp args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_NEON :
	$(CC) $(CCFLAGS) -mfpu=neon -o xprobe_neon \
              $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_NEON.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_neon args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_VXZ :
	$(CC) $(CCFLAGS) -march=native -mvx -mzvector -o xprobe_vxz \
           $(SRCdir)/backend/probe_dvec.c $(SRCdir)/backend/probe_vxz.c
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_vxz args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_FPV3D16MAC :
	$(CC) $(CCFLAGS) -mfpu=vfpv3-d16 -o xprobe_fpv3d16mac $(SRCdir)/backend/probe_dmac.c $(SRCdir)/backend/probe_FPV3D16MAC.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_fpv3d16mac args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_FPV3D32MAC :
	$(CC) $(CCFLAGS) -mfpu=vfpv3 -o xprobe_fpv3d32mac $(SRCdir)/backend/probe_dmac.c $(SRCdir)/backend/probe_FPV3D32MAC.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_fpv3d32mac args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_FPV3D16MACNEON :
	$(CC) $(CCFLAGS) -mfpu=neon-fp16 -o xprobe_fpv3d16macneon $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_FPV3D16MACNEON.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_fpv3d16macneon args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_FPV3D32MACNEON :
	$(CC) $(CCFLAGS) -mfpu=neon -o xprobe_fpv3d32macneon $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_FPV3D32MACNEON.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_fpv3d32macneon args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_3DNow :
	$(CC) $(CCFLAGS) -o xprobe_3dnow $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_3DNow.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_3dnow args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_VSX :
	$(CC) $(CCFLAGS) -o xprobe_vsx $(SRCdir)/backend/probe_dvec.c $(SRCdir)/backend/probe_VSX.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_vsx args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_AltiVec :
	$(CC) $(CCFLAGS) -o xprobe_altivec $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_AltiVec.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_altivec args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SSE2 :
	$(CC) $(CCFLAGS) -o xprobe_sse2 $(SRCdir)/backend/probe_dvec.c $(SRCdir)/backend/probe_SSE2.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_sse2 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SSE1 :
	$(CC) $(CCFLAGS) -o xprobe_sse1 $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_SSE1.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_sse1 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SSE3 :
	$(CC) $(CCFLAGS) -o xprobe_sse3 $(SRCdir)/backend/probe_dSSE3.c $(SRCdir)/backend/probe_SSE3.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_sse3 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_AVXFMA4 :
	$(CC) $(CCFLAGS) -o xprobe_avxmac $(SRCdir)/backend/probe_dAVX.c \
              $(SRCdir)/backend/probe_AVXFMA4.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_avxmac args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_AVXMAC :
	$(CC) $(CCFLAGS) -o xprobe_avxmac $(SRCdir)/backend/probe_dAVX.c \
              $(SRCdir)/backend/probe_AVXMAC.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_avxmac args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_AVX :
	$(CC) $(CCFLAGS) -o xprobe_avx $(SRCdir)/backend/probe_dAVX.c \
              $(SRCdir)/backend/probe_AVX.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_avx args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_WIN64 :
	$(CC) $(CCFLAGS) -o xprobe_WIN64 $(SRCdir)/backend/probe_aff_WIN64.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_WIN64 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_WIN :
	$(CC) $(CCFLAGS) -o xprobe_WIN $(SRCdir)/backend/probe_aff_WIN.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_WIN args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_CPUSET :
	$(CC) $(CCFLAGS) -o xprobe_CPUSET $(SRCdir)/backend/probe_aff_CPUSET.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_CPUSET args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SETPROCNP :
	$(CC) $(CCFLAGS) -o xprobe_SETPROCNP $(SRCdir)/backend/probe_aff_SETPROCNP.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_SETPROCNP args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SETAFFNP :
	$(CC) $(CCFLAGS) -o xprobe_SETAFFNP $(SRCdir)/backend/probe_aff_SETAFFNP.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_SETAFFNP args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SCHED :
	$(CC) $(CCFLAGS) -o xprobe_SCHED $(SRCdir)/backend/probe_aff_SCHED.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_SCHED args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_RUNON :
	$(CC) $(CCFLAGS) -o xprobe_RUNON $(SRCdir)/backend/probe_aff_RUNON.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_RUNON args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_PLPA :
	$(CC) $(CCFLAGS) -o xprobe_PLPA $(SRCdir)/backend/probe_aff_PLPA.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_PLPA args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_PBIND :
	$(CC) $(CCFLAGS) -o xprobe_PBIND $(SRCdir)/backend/probe_aff_PBIND.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_PBIND args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_BINDP :
	$(CC) $(CCFLAGS) -o xprobe_BINDP $(SRCdir)/backend/probe_aff_BINDP.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_BINDP args="$(args)" \
                redir=config0.out
	- cat config0.out

IRun_GAS_S390 :
	$(CC) $(CCFLAGS) -o xprobe_gas_s390 $(SRCdir)/backend/probe_this_asm.c $(SRCdir)/backend/probe_gas_s390.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_gas_s390 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_GAS_ARM64 :

=== debian/changelog ===
atlas (3.10.3-5) unstable; urgency=low

  * libatlas3-base Conflicts+Replaces libcblas3. (Closes: #874802)
  * libatlas-base-dev Conflicts+Replaces libcblas-dev. (Closes: #874803)

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 13 Sep 2017 22:29:27 +0200

atlas (3.10.3-4) unstable; urgency=low

  * Multi-archify the package.
    Incidentally, drop the dependency of libatlas-base-dev on libblas-dev, since
    cblas.h is now managed by the alternative.
  * kfreebsd.patch: update using the fix applied upstream.
  * Bump Standards-Version to 4.1.0.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 09 Sep 2017 10:27:50 +0200

atlas (3.10.3-3) unstable; urgency=medium

  * d/control: libatlas-base-dev now directly depends on libblas-dev.
    This is necessary for having cblas.h under /usr/include (as was
    the case before libatlas-dev was dropped).
  * Add archdef for sparc64.
  * d/control: mark libatlas-doc as M-A foreign.
  * d/orig-tar.{sh,exclude}: fetch TexDoc subdir from git instead of CVS.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 16 Aug 2017 22:30:36 +0200

atlas (3.10.3-2) unstable; urgency=medium

  * “The frantic post-release package overhaul”

  [ Sébastien Villemot ]
  * d/copyright: complete rewrite using machine-readable format 1.0.
  * Merge libatlas-dev into libatlas-base-dev, drop the former.
  * Drop useless patches:
    + d/p/10_s390.diff
    + d/p/17_hppa.diff
    + d/p/18_alpha.diff
    + d/p/20_armel.diff
    + d/p/22_sh.diff
    + d/p/16_warning-removed.diff
  * d/p/ppc64-endianness.patch: new patch, fix machine detection on ppc64.
  * d/p/fix-typos.patch: new patch.
  * d/p/missing-cflags.patch: new patch.
  * Drop patches for creating full BLAS and LAPACK libs, and shared libs.
    Replace them by rules in debian/rules.
    Also no longer embed lib(pt)?cblas.a into liblapack.a, not needed.
  * d/rules:
    + Rewrite and simplify using dh (drop cdbs).
    + Support parallel=N in DEB_BUILD_OPTIONS.
    + Support nodoc in DEB_BUILD_OPTIONS.
    + Inject flags from dpkg-buildflags into the generic package.
      Incidentally, this means that the noopt and nostrip flags of
      DEB_BUILD_OPTIONS are now supported. (Closes: #697203)
    + Do not use "-Ss flapack" option of configure, it does not work.
  * d/watch:
    + Bump to format version 4. Update d/orig-tar.sh to make it compatible with
      the new invocation syntax.
    + Add +ds suffix to orig tarball, since we're repacking it.
  * d/control:
    + Use canonical URL in Vcs-Browser.
    + Drop Suggests on libblas-doc, superseded by liblapack-doc.
    + Remove several unnecessary build-dependencies.
    + Bump Standards-Version to 4.0.1.
    + libatlas-test now marked priority optional, per Policy 4.0.1.
  * Bump debhelper compat level to 10.
  * Remove obsolete TODO.
  * d/lapack-atlas.in: add Requires.private on blas.
  * Custom package:
    + Use DEB_BUILD_OPTIONS=custom as new interface.
      By the way, no longer automatically append a changelog entry.
      (Closes: #854781)
    + Improve the instructions in README.Debian.
    + Add -lpthread to dynamic libs and .pc file when relevant.
    + Ship libpt{c,f77}blas.so when relevant. (Closes: #737834)
  * armhf generic package: stop using Cortex-a7 machtype, enable VFPv3-D16.
  * Add archdef for ppc64.

  [ Dimitri John Ledkov ]
  * d/rules: on Ubuntu s390x set ARCHS to z12.
  * d/archdefs/s390x: add IBMz12 tarball

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 10 Aug 2017 18:39:08 +0200

atlas (3.10.3-1) unstable; urgency=low

  [ Sébastien Villemot ]
  * Imported Upstream version 3.10.3. (Closes: #833139)
  * Drop d/p/cpu-throttling-check.diff, no longer needed.
    Replace it with new --cripple-atlas-performance option.
  * Drop d/p/ppc64el-new-archdef-name.patch, applied upstream.
  * Drop d/p/armhf.diff, no longer needed.
  * d/rules: update architecture/ISA names/enums.
  * Update archdefs for ppc64el, arm64 and armhf.
  * d/control:
    + drop useless Section field for binary package libatlas-test.
    + bump Standards-Version to 3.9.8, no changes needed.
    + use secure URLs for Vcs-* fields.
  * Improve shell syntax in preinst scripts.
    Thanks to Wolfgang Karall-Ahlborn (Closes: #805406)

  [ Dimitri John Ledkov ]
  * d/rules: on ppc64el set ARCHES to POWER8.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 06 Aug 2016 20:27:27 +0200

=== debian/control ===
Source: atlas
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 10),
               dh-exec,
               gfortran,
               liblapack-pic (>= 3.7.1-2~),
               texlive-latex-base,
               ghostscript
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/atlas.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/atlas.git
Homepage: http://math-atlas.sourceforge.net/

Package: libatlas3-base
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libopenblas-base (<< 0.2.20+ds-3~),
        libatlas-base-dev (<< 3.10.3-4~)
Conflicts: libcblas3
Provides: libblas.so.3,
          liblapack.so.3
Replaces: libcblas3
Built-Using: ${Built-Using}
Description: Automatically Tuned Linear Algebra Software, generic shared
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 The libraries in this package are built without any processor extension
 instructions, and should run on all processors of this general
 architecture, albeit less than optimally.  
 . 
 If you want to create an ATLAS packaged optimized for your processor, see the
 section: "Building Optimized Atlas Packages on your ARCH" in README.Debian

Package: libatlas-base-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libatlas3-base (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libatlas-doc,
          liblapack-doc
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libopenblas-dev (<< 0.2.20+ds-3~),
        libatlas-dev (<< 3.10.3-2)
Conflicts: libcblas-dev
Provides: libblas.so,
          liblapack.so
Replaces: libatlas-dev (<< 3.10.3-2),
          libcblas-dev
Built-Using: ${Built-Using}
Description: Automatically Tuned Linear Algebra Software, generic static
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package includes the headers, the static libraries and symbolic links
 needed for program development.

Package: libatlas-test
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Automatically Tuned Linear Algebra Software, test programs
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package provides dynamically linked testing and bench-marking
 binaries to compare the BLAS and ATLAS libraries on your system.

Package: libatlas-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Automatically Tuned Linear Algebra Software, documentation
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package provides documentation on the ATLAS libraries useful for
 developers.

=== debian/rules ===
#!/usr/bin/make -f

# Some ATLAS code uses improper format strings, so disable this
export DEB_BUILD_MAINT_OPTIONS=hardening=-format

include /usr/share/dpkg/default.mk

# Parallel make variable, used by ATLAS build system
PMAKE := make
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
PMAKE += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

GFORTRAN_LIB_PATH := $(shell $(CC) -print-search-dirs | grep ^install: | awk '{print $$2}')

# Flags common to both the generic and custom packages
CONFIGURE_FLAGS := --prefix="$(CURDIR)/debian/tmp"			 	\
	--incdir="$(CURDIR)/debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/"	\
	--libdir="$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/"		\
	--shared								\
	-D c -DWALL 								\
	-Ss f77lib "-L$(GFORTRAN_LIB_PATH) -lgfortran -lgcc_s -lpthread"	\
	-Ss pmake '$(PMAKE)'							\
	-v 2

ifeq (,$(filter custom,$(DEB_BUILD_OPTIONS)))
# Building the generic package, so enforce more configuration settings to make
# the package independent of the build host hardware.

# In particular, force the MACHTYPE and ISA.
# The following strings and numbers come from xprint_enums (compilable
# with "make -C build xprint_enums").
# N.B.: They can change across releases!

ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
UBUNTU := yes
endif

# Select the machine type
ifeq ($(DEB_HOST_ARCH),s390x)
MACHTYPE := $(if $(UBUNTU),IBMz12,IBMz9)
else ifeq ($(DEB_HOST_ARCH_CPU),ppc64el)
MACHTYPE := POWER8
else ifeq ($(DEB_HOST_ARCH_CPU),i386)
# See http://math-atlas.sourceforge.net/atlas_install/node32.html
MACHTYPE := x86x87
else ifeq ($(DEB_HOST_ARCH_CPU),amd64)
MACHTYPE := x86SSE2
else
# The same as UNKNOWN, except that it does not try autodetection
# See debian/patches/generic.diff
MACHTYPE := GENERIC
endif

# ISA corresponds to the instruction set architecture:
# - 1 means no instruction set extension
# - 768 means SSE1+SSE2 (always available on amd64)
# - 16384 means FPV3D16MAC (always available on armhf)
# VSX should also be enabled on ppc64el, but as of 3.10.3-2 it FTBFS.
ifeq ($(DEB_HOST_ARCH_CPU),amd64)
ISA := 768
else ifeq ($(DEB_HOST_ARCH),armhf)
ISA := 16384
else
ISA := 1
endif

# - the cripple-atlas-performance flag is needed for disabling the CPU
#   throttling check, because on some buildds CPU throttling is enabled and we
#   have no way of disabling it;
# - disable multi-threading (-t 0), because otherwise the package FTBFS on some
#   single-processor machines;
# - enforce gcc as the compiler for all uses (except for compiling probes,
#   in --cc), because otherwise architectural defaults do not work.
CONFIGURE_FLAGS +=	 					\
	-b $(DEB_HOST_ARCH_BITS)				\
	-A $(MACHTYPE) 						\
	-V $(ISA) 						\
	-t 0 							\
	--cc="$(CC)" 						\
	--cflags="$(CPPFLAGS) $(CFLAGS)"			\
	-C acg gcc						\
	-F acg "$(CPPFLAGS) $(CFLAGS)"				\
	-C if gfortran						\
	-F if "$(FFLAGS)"					\
	-Ss ADdir ../../debian/archdefs/$(DEB_HOST_ARCH_CPU)	\
	--cripple-atlas-performance

else
# Flags specific to the custom package

# Uncomment the following if the ATLAS build system still complains after you
# have set all the CPU governors to "performance"
#CONFIGURE_FLAGS += --cripple-atlas-performance
endif


%:
	dh $@

override_dh_auto_configure:
	mkdir -p build/
	cd build && ../configure $(CONFIGURE_FLAGS)
	@echo "=============================================="
	@echo -n "Configured arch: "
	@grep ARCH < build/Make.inc | head -1 | awk '{print $$3}'
	@echo "=============================================="

override_dh_auto_build:
	make -C build

	# We do not ship the lib{s,t}atlas.so created by ATLAS build system, they have an awkward name and an incorrect SONAME
	# Rather create our shared versions of individual ATLAS libraries
	gfortran $(LDFLAGS) -shared -Wl,-soname=libatlas.so.3 -o libatlas.so.$(DEB_VERSION_UPSTREAM) \
		-Wl,--whole-archive build/lib/libatlas.a -Wl,--no-whole-archive \
		$$(test -f build/lib/libptcblas.a && echo -lpthread) -lc -lm
	ln -sf libatlas.so.$(DEB_VERSION_UPSTREAM) libatlas.so.3
	ln -sf libatlas.so.$(DEB_VERSION_UPSTREAM) libatlas.so

	gfortran $(LDFLAGS) -shared -Wl,-soname=libcblas.so.3 -o libcblas.so.$(DEB_VERSION_UPSTREAM) \
		-Wl,--whole-archive build/lib/libcblas.a -Wl,--no-whole-archive \
		-L. -latlas -lm -lc
	ln -sf libcblas.so.$(DEB_VERSION_UPSTREAM) libcblas.so.3
	ln -sf libcblas.so.$(DEB_VERSION_UPSTREAM) libcblas.so

	gfortran $(LDFLAGS) -shared -Wl,-soname=libf77blas.so.3 -o libf77blas.so.$(DEB_VERSION_UPSTREAM) \
		-Wl,--whole-archive build/lib/libf77blas.a -Wl,--no-whole-archive \
		-L. -lcblas -latlas -lm -lc
	ln -sf libf77blas.so.$(DEB_VERSION_UPSTREAM) libf77blas.so.3
	ln -sf libf77blas.so.$(DEB_VERSION_UPSTREAM) libf77blas.so

	gfortran $(LDFLAGS) -shared -Wl,-soname=liblapack_atlas.so.3 -o liblapack_atlas.so.$(DEB_VERSION_UPSTREAM) \
		-Wl,--whole-archive build/lib/liblapack_atlas.a -Wl,--no-whole-archive \
		-L. -lf77blas -lcblas -latlas -lm -lc
	ln -sf liblapack_atlas.so.$(DEB_VERSION_UPSTREAM) liblapack_atlas.so.3
	ln -sf liblapack_atlas.so.$(DEB_VERSION_UPSTREAM) liblapack_atlas.so

	if test -f build/lib/libptcblas.a; then \
		gfortran $(LDFLAGS) -shared -Wl,-soname=libptcblas.so.3 \
			-o libptcblas.so.$(DEB_VERSION_UPSTREAM) \
			-Wl,--whole-archive build/lib/libptcblas.a -Wl,--no-whole-archive \
			-L. -latlas -lm -lc; \
		ln -sf libptcblas.so.$(DEB_VERSION_UPSTREAM) libptcblas.so.3; \
		ln -sf libptcblas.so.$(DEB_VERSION_UPSTREAM) libptcblas.so; \
	fi

	if test -f build/lib/libptf77blas.a; then \
		gfortran $(LDFLAGS) -shared -Wl,-soname=libptf77blas.so.3 \
			-o libptf77blas.so.$(DEB_VERSION_UPSTREAM) \
			-Wl,--whole-archive build/lib/libptf77blas.a -Wl,--no-whole-archive \
			-L. -lptcblas -latlas -lm -lc; \
		ln -sf libptf77blas.so.$(DEB_VERSION_UPSTREAM) libptf77blas.so.3; \
		ln -sf libptf77blas.so.$(DEB_VERSION_UPSTREAM) libptf77blas.so; \
	fi

	# Create static and shared full BLAS
	mkdir tmp
	cd tmp && \
		ar x ../build/lib/libatlas.a && \
		if test -f ../build/lib/libptf77blas.a -a -f ../build/lib/libptcblas.a; then \
			ar x ../build/lib/libptf77blas.a && \
			ar x ../build/lib/libptcblas.a; \
		else \
			ar x ../build/lib/libf77blas.a && \
			ar x ../build/lib/libcblas.a; \
		fi
	ar r libblas.a tmp/*.o
	rm -rf tmp
	gfortran $(LDFLAGS) -shared -Wl,-soname=libblas.so.3 -o libblas.so.$(DEB_VERSION_UPSTREAM) \
		-Wl,--whole-archive libblas.a -Wl,--no-whole-archive \
		-L. -latlas $$(test -f build/lib/libptcblas.a && echo -lpthread) -lm -lc
	ln -sf libblas.so.$(DEB_VERSION_UPSTREAM) libblas.so.3
	ln -sf libblas.so.$(DEB_VERSION_UPSTREAM) libblas.so

	# Kludge to fix blas-atlas.pc by adding -lpthread when needed
	if test -f build/lib/libptcblas.a; then sed -i 's/^Libs.private: \(.*\)/Libs.private: \1 -lpthread/' debian/blas-atlas.pc; fi

	# Create static and shared full LAPACK
	# Note that we unpack liblapack_atlas.a after liblapack_pic.a, in order to overwrite routines in the latter
	mkdir tmp
	cd tmp && \
		ar x /usr/lib/$(DEB_HOST_MULTIARCH)/liblapack_pic.a && \
		ar x ../build/lib/liblapack_atlas.a
	ar r liblapack.a tmp/*.o
	rm -rf tmp
	gfortran $(LDFLAGS) -shared -Wl,-soname=liblapack.so.3 -o liblapack.so.$(DEB_VERSION_UPSTREAM) \
		-Wl,--whole-archive liblapack.a -Wl,--no-whole-archive \
		-L. -lblas -latlas -lm -lc
	ln -sf liblapack.so.$(DEB_VERSION_UPSTREAM) liblapack.so.3
	ln -sf liblapack.so.$(DEB_VERSION_UPSTREAM) liblapack.so

	# Build PDF documentation
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	make -C TexDoc atlas_contrib.pdf atlas_devel.pdf atlas_install.pdf cblasqref.pdf f77blasqref.pdf lapackqref.pdf
endif

override_dh_auto_test:
	make -C build check
	if test -f build/lib/libptcblas.a; then make -C build ptcheck; fi

override_dh_auto_install:
	make -C build install # The build system does not support setting DESTDIR at install time
	mv debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/cblas.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/cblas-atlas.h

# We want packages using libblas/liblapack to depend on any BLAS/LAPACK

=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds$//,oversionmangle=s/(.*)/$1+ds/ \
http://sf.net/math-atlas/atlas(\d.*)\.tar\.bz2 debian debian/orig-tar.sh
